Attribute VB_Name = "Module2"

'PADS PCB VB Script -Report Route Segment Length Ver.1.1 07-03-01
'Displays the total length of all selected route segments, connections
'Select any route segments by first selecting one segment then 
'Ctrl+select any additional segments or first then shift+last segment
'then Apply. Pin-Pair (connection)and net selection may also be made
'using RMB,Select Pin Pairs \Nets.
'Note: Function Keys are disabled in Pads when VB scripts are active.
'Total routed length is reported in current design units.
'Written by Ron Olinyk, Mindlink Technologies, rolinyk@execulink.com 
'Ver1.1 07-03-01 Improved RouteLen function, added pin-pair,net capability.

Dim objs As Object
Dim objconn As Object
Dim objnet As Object

Sub Main
  
'Spit out the info to a dialog box
 
	Begin Dialog UserDialog 290,91,"Selected Route Segment Length",.CallbackFunc ' %GRID:10,7,1,1
		Text 30,14,240,14,"Length of all selected route segments =",.Text9
		Text 183,37,40,14,"",.Text2
		OKButton 130,63,60,21
		TextBox 100,35,80,16,.TextBox1
		PushButton 40,63,70,21,"Apply",.PushButton1
		PushButton 210,63,60,21,"Help",.PushButton2
	End Dialog
	Dim dlg As UserDialog
	Dialog dlg
 
End Sub

Private Function CallbackFunc(DlgItem$, Action%, SuppValue%) As Boolean

	Select Case Action%
	Case 1 ' Dialog box initialization
		DlgText "TextBox1", "Select"
		
	Case 2 ' Value changing or button pressed
	  Rem CallbackFunc = True ' Prevent button press from closing the dialog box
               
		If DlgItem$ = "OK" Or DlgItem$ = "PushButton1" Then
		    DlgText "Textbox1", Format(RouteLen_fncn, "0.000")
		    DlgText "Text2", Unit_fncn
			If DlgItem$ = "PushButton1" Then  CallbackFunc = True
		ElseIf DlgItem$ = "PushButton2" Then  
		    Help_mess
		      
		    If DlgItem$ = "PushButton2" Then  CallbackFunc = True
		End If
				
	Case 3 ' TextBox or ComboBox text changed
	
	Case 4 ' Focus changed
			
	Case 5 ' Idle
		Rem CallbackFunc = True ' Continue getting idle actions
	Case 6
				
	End Select
End Function
'************************
Sub Help_mess
Dim Help_msg$
  Help_msg = "Select route segment.." & vbCr
  Help_msg = Help_msg & "..or select first segment then Ctrl+select others" & vbCr
  Help_msg = Help_msg & "..or select first and Shift+last segment" & vbCr
  Help_msg = Help_msg & "..or window select anything." & vbCr
  Help_msg = Help_msg & "..or RMB\Select Pin Pairs" & vbCr
  Help_msg = Help_msg & "..or RMB\Select Nets" & vbCr
  Help_msg = Help_msg & "Then Apply."
  MsgBox Help_msg,32,"Help...dude!"
End Sub
'************************
' Get Current Design Units
Private Function Unit_fncn() As String
	currUnit = ActiveDocument.unit
    If currUnit = 2 Then
      currunitName$ = "mil"
    ElseIf currUnit = 3 Then
      currunitName$ = "in."
    ElseIf currUnit = 4 Then
      currunitName$ = "mm"
    End If	
    Unit_fncn = currunitName
End Function
'**********************
'Find and add selected route segments
Private Function RouteLen_fncn() As String
		rtelen = 0
       
		Set objs = ActiveDocument.GetObjects(ppcbObjectTypeRouteSegment, ,True)
		Set objconn = ActiveDocument.GetObjects(ppcbObjectTypeConnection, ,True)
		Set objnet = ActiveDocument.GetObjects(ppcbObjectTypeNet, ,True)
        If objs.Count > 0 Then
         For i=1 To objs.Count
           rtelen = rtelen + objs.Item(i).Length
         Next i
        End If
        If objconn.Count > 0 Then
         For n=1 To objconn.Count
           For i=1 To objconn.Item(n).RouteSegments.Count
             rtelen = rtelen + objconn.Item(n).RouteSegments.Item(i).Length
           Next i 
         Next n
        End If 
        If objnet.Count > 0 Then
         For n=1 To objnet.Count
          For i=1 To objnet.Item(n).Connections.Count
             rtelen = rtelen + objnet.Item(n).Connections.Item(i).Length
           Next i 
         Next n 
        End If
        
        RouteLen_fncn = CStr(rtelen)
        
End Function
'**********************
'**********************
'**********************
